/*http://hubbard.engr.scu.edu/embedded/avr/avrlib/index.html

Hi

alle Megas haben ein TWI (aka I2C) Interface hardwaremig drin. Eine
relativ einfache Nutzung (bertragen von 2 Byte als Slave-Transmitter)
sieht dann so aus:
*/


#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <avr/pgmspace.h>
#include <avr/twi.h>



// um Register auch bitweise in Binrformat ansprechen zu knnen
#define BIN8(b7,b6,b5,b4,b3,b2,b1,b0) ((unsigned char)\
                          (b0 << 0)\
                        | (b1 << 1)\
                        | (b2 << 2)\
                        | (b3 << 3)\
                        | (b4 << 4)\
                        | (b5 << 5)\
                        | (b6 << 6)\
                        | (b7 << 7))

#define OWN_ADR  4



void uart_send_u8(uint8_t x);
void uart_send_u16(uint16_t x);
void i2c_init(void);

volatile uint8_t i2c_val1=5;

int main (void) 
{

	PORTB=BIN8(1,1,1,1,0,1,1,0); 		// pull up PINs... (nur wenn in DDR als Eingang def)
	PORTC=BIN8(1,0,0,1,1,1,1,1); 		// pull up PINs... (nur wenn in DDR als Eingang def)
	PORTD=BIN8(0,0,1,1,1,0,1,1); 		// pull up PINs... (nur wenn in DDR als Eingang def) 
	
	DDRB=  BIN8(0,0,0,0,1,0,0,1);		// Datenrichtung PortB 	0=Eingang 1=Ausgang
	DDRC=  BIN8(0,0,0,0,0,0,0,0);		// Datenrichtung PortC
	DDRD=  BIN8(1,1,0,0,0,1,0,0);		// Datenrichtung PortD
	
    
	UBRRL=12;					// Set baudrate 38400  (8MHz/ 16*(UBRR+1)=baud  =12	
	UCSRB|= _BV(RXEN)|_BV(TXEN);		// UART recieve on, UART Send on	
	UCSRB|= _BV(RXCIE);			// UART RX complete interrupt enable
	
	
	
	
	i2c_init();
	
	sei();
	
	
	for (;;){asm volatile ("nop");}
	
	return 0;
} 






// TWI-Schnittstelle initialisieren  Slave Transmitter Mode
void i2c_init()
{
  TWAR=0;
  TWAR|= (OWN_ADR<<1); 	// Reciever adress
  TWCR = (1<<TWEN)|(1<<TWEA)|(1<<TWIE);  
  
  // TWEN : TWI Enable
  // TWSTA : 1=master 0=slave
  // TWEA : TWI Enable Acknowledge Bit
  // TWIE : TWI Interrupt Enable

}				





  //Behandelt die INT's des TWI
SIGNAL(SIG_2WIRE_SERIAL) 
{  

   // Slave status (receiver mode)
   if(TWSR==0x60)  
  {
    TWCR=(1<<TWEN)|(1<<TWINT)|(1<<TWEA)|(1<<TWIE);	// In next action: Data byte will be received and ACK will be returned
  }
  else if((TWSR==0x88))
  {
    TWCR=(1<<TWEN)|(1<<TWINT)|(1<<TWIE);
  }
  else if(TWSR==0x80)
  {
    i2c_val1=TWDR;
    TWCR=(1<<TWEN)|(1<<TWINT)|(1<<TWEA)|(1<<TWIE);
  } 
   else if(TWSR==0xA0)  //receive
  {
    i2c_val1=TWDR;
   TWCR=(1<<TWEN)|(1<<TWINT)|(1<<TWEA)|(1<<TWIE);
  } 
  
  
  //if(i2c_val1==2) PORTD=0xFF;  // test LED
  //else PORTD=0;

  
  if(TWSR==0xA8) // Slave status (transmitter mode)
  {
    TWDR= i2c_val1;	//transmit
    TWCR=(1<<TWEN)|(1<<TWINT)|(1<<TWEA)|(1<<TWIE);
  }
  else if(TWSR==0xC0)
  {
    TWCR=(1<<TWEN)|(1<<TWINT)|(1<<TWEA)|(1<<TWIE);
  }
  
  
  
}

















